<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_user.php                                           ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/parameters.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("site_users");

	$type = get_param("type");
	$user_type_id = get_param("user_type_id");
	$user_id = get_param("user_id");
	if (strlen($user_type_id)) {
		$type_id = $user_type_id;
	} else if (strlen($user_id)) {
		$sql  = " SELECT user_type_id FROM " . $table_prefix . "users ";
		$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
		$type_id = get_db_value($sql);
	} else {
		$type_id = $type;
	}
	$setting_type = "user_profile_" . $type_id;

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_user.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_users_href", "admin_users.php");
	$t->set_var("admin_user_href", "admin_user.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_upload_href", "admin_upload.php");

	$t->set_var("PROFILE_TITLE",      PROFILE_TITLE);
	$t->set_var("EDIT_PROFILE_MSG",   EDIT_PROFILE_MSG);
	$t->set_var("MY_ACCOUNT_MSG",     MY_ACCOUNT_MSG);
	$t->set_var("LOGIN_INFO_MSG",     LOGIN_INFO_MSG);
	$t->set_var("PERSONAL_DETAILS_MSG", PERSONAL_DETAILS_MSG);
	$t->set_var("DELIVERY_DETAILS_MSG", DELIVERY_DETAILS_MSG);
	$t->set_var("SAME_DETAILS_MSG",   SAME_DETAILS_MSG);
	$t->set_var("REGISTER_BUTTON",    REGISTER_BUTTON);
	$t->set_var("UPDATE_BUTTON",      UPDATE_BUTTON);
	$t->set_var("CANCEL_BUTTON",      CANCEL_BUTTON);
	$t->set_var("LOGIN_FIELD",        LOGIN_FIELD);
	$t->set_var("PASSWORD_FIELD",     PASSWORD_FIELD);
	$t->set_var("CONFIRM_PASS_FIELD", CONFIRM_PASS_FIELD);
	$t->set_var("NAME_FIELD",         NAME_FIELD);
	$t->set_var("FIRST_NAME_FIELD",   FIRST_NAME_FIELD);
	$t->set_var("LAST_NAME_FIELD",    LAST_NAME_FIELD);
	$t->set_var("COMPANY_SELECT_FIELD", COMPANY_SELECT_FIELD);
	$t->set_var("COMPANY_NAME_FIELD", COMPANY_NAME_FIELD);
	$t->set_var("EMAIL_FIELD",        EMAIL_FIELD);
	$t->set_var("STREET_FIRST_FIELD", STREET_FIRST_FIELD);
	$t->set_var("STREET_SECOND_FIELD",STREET_SECOND_FIELD);
	$t->set_var("CITY_FIELD",         CITY_FIELD);
	$t->set_var("PROVINCE_FIELD",     PROVINCE_FIELD);
	$t->set_var("STATE_FIELD",        STATE_FIELD);
	$t->set_var("ZIP_FIELD",          ZIP_FIELD);
	$t->set_var("COUNTRY_FIELD",      COUNTRY_FIELD);
	$t->set_var("PHONE_FIELD",        PHONE_FIELD);
	$t->set_var("DAYTIME_PHONE_FIELD",DAYTIME_PHONE_FIELD);
	$t->set_var("EVENING_PHONE_FIELD",EVENING_PHONE_FIELD);
	$t->set_var("CELL_PHONE_FIELD",   CELL_PHONE_FIELD);
	$t->set_var("FAX_FIELD",          FAX_FIELD);
	$t->set_var("SUBSCRIBE_CHECKBOX_MSG",SUBSCRIBE_CHECKBOX_MSG);
	$t->set_var("PERSONAL_IMAGE_FIELD", PERSONAL_IMAGE_FIELD);
	$t->set_var("UPLOAD_IMAGE_MSG",     UPLOAD_IMAGE_MSG);


	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
	$db->query($sql);
	while($db->next_record()) {
		$user_profile[$db->f("setting_name")] = $db->f("setting_value");
	}

	$r = new VA_Record($table_prefix . "users");
	$return_page = "admin_users.php";

	$r->add_where("user_id", INTEGER);

	$approved_values = array(array("1", YES_MSG), array("0", NO_MSG));
	$r->add_radio("is_approved", INTEGER, $approved_values, "Approved");
	$user_types = get_db_values("SELECT type_id,type_name FROM " . $table_prefix . "user_types ", "");
	$r->add_select("user_type_id", TEXT, $user_types, "User Type");
	$discount_types = array( 
		array("", ""), array(0, "Not available"), array(1, "Percentage per product/option selling price"), 
		array(2, "Amount per product"), array(3, "Percentage per product selling price"),
		array(4, "Percentage per (selling price - buying price)")
	);
	$r->add_select("discount_type", INTEGER, $discount_types);
	$r->change_property("discount_type", DEFAULT_VALUE, 0);
	$r->add_textbox("discount_amount", NUMBER, "Discount Amount");

	if(!$user_id)
	{
		$r->add_textbox("login", TEXT, "Login");
		$r->parameters["login"][REQUIRED] = true;
		$r->parameters["login"][UNIQUE] = true;
		$r->parameters["login"][MIN_LENGTH] = 3;
		$r->add_textbox("password", TEXT, PASSWORD_FIELD);
		$r->parameters["password"][REQUIRED] = true;
		$r->parameters["password"][MIN_LENGTH] = 3;
		$r->add_textbox("confirm", TEXT, CONFIRM_PASS_FIELD);
		$r->change_property("confirm", USE_IN_SELECT, false);
		$r->change_property("confirm", USE_IN_INSERT, false);
		$r->change_property("confirm", USE_IN_UPDATE, false);
		$r->change_property("password", MATCHED, "confirm");
	}

	$companies = get_db_values("SELECT company_id,company_name FROM " . $table_prefix . "companies ", array(array("", SELECT_COMPANY_MSG)));
	$states = get_db_values("SELECT state_code,state_name FROM " . $table_prefix . "states", array(array("", SELECT_STATE_MSG)));
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order ", array(array("", SELECT_COUNTRY_MSG)));

	$r->add_textbox("name", TEXT, NAME_FIELD);
	$r->change_property("name", USE_SQL_NULL, false);
	$r->add_textbox("first_name", TEXT, FIRST_NAME_FIELD);
	$r->change_property("first_name", USE_SQL_NULL, false);
	$r->add_textbox("last_name", TEXT, LAST_NAME_FIELD);
	$r->change_property("last_name", USE_SQL_NULL, false);
	$r->add_select("company_id", INTEGER, $companies, COMPANY_SELECT_FIELD);
	$r->add_textbox("company_name", TEXT, COMPANY_NAME_FIELD);
	$r->add_textbox("email", TEXT, EMAIL_FIELD);
	$r->change_property("email", USE_SQL_NULL, false);
	$r->change_property("email", REGEXP_MASK, EMAIL_REGEXP);
	$r->change_property("email", UNIQUE, true);
	$r->add_textbox("address1", TEXT, STREET_FIRST_FIELD);
	$r->add_textbox("address2", TEXT, STREET_SECOND_FIELD);
	$r->add_textbox("city", TEXT, CITY_FIELD);
	$r->add_textbox("province", TEXT, PROVINCE_FIELD);
	$r->add_select("state_code", TEXT, $states, STATE_FIELD);
	$r->add_textbox("zip", TEXT, ZIP_FIELD);
	$r->add_select("country_code", TEXT, $countries, COUNTRY_FIELD);
	$r->add_textbox("phone", TEXT, "Phone");
	$r->add_textbox("daytime_phone", TEXT, DAYTIME_PHONE_FIELD);
	$r->add_textbox("evening_phone", TEXT, EVENING_PHONE_FIELD);
	$r->add_textbox("cell_phone", TEXT, CELL_PHONE_FIELD);
	$r->add_textbox("fax", TEXT, FAX_FIELD);
	$r->add_textbox("personal_image", TEXT, PERSONAL_IMAGE_FIELD);
	if(!isset($user_profile["show_personal_image"]) || $user_profile["show_personal_image"] != 1) {
		$r->parameters["personal_image"][SHOW] = false;
	}

	$r->add_textbox("delivery_name", TEXT, DELIVERY_MSG." ".NAME_FIELD);
	$r->add_textbox("delivery_first_name", TEXT, DELIVERY_MSG." ".FIRST_NAME_FIELD);
	$r->add_textbox("delivery_last_name", TEXT, DELIVERY_MSG." ".LAST_NAME_FIELD);
	$r->add_select("delivery_company_id", INTEGER, $companies, DELIVERY_MSG." ".COMPANY_SELECT_FIELD);
	$r->add_textbox("delivery_company_name", TEXT, DELIVERY_MSG." ".COMPANY_NAME_FIELD);
	$r->add_textbox("delivery_email", TEXT, DELIVERY_MSG." ".EMAIL_FIELD);
	$r->change_property("delivery_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("delivery_address1", TEXT, DELIVERY_MSG." ".STREET_FIRST_FIELD);
	$r->add_textbox("delivery_address2", TEXT, DELIVERY_MSG." ".STREET_SECOND_FIELD);
	$r->add_textbox("delivery_city", TEXT, DELIVERY_MSG." ".CITY_FIELD);
	$r->add_textbox("delivery_province", TEXT, DELIVERY_MSG." ".PROVINCE_FIELD);
	$r->add_select("delivery_state_code", TEXT, $states, DELIVERY_MSG." ".STATE_FIELD);
	$r->add_textbox("delivery_zip", TEXT, DELIVERY_MSG." ".ZIP_FIELD);
	$r->add_select("delivery_country_code", TEXT, $countries, DELIVERY_MSG." ".COUNTRY_FIELD);
	$r->add_textbox("delivery_phone", TEXT, DELIVERY_MSG." ".PHONE_FIELD);
	$r->add_textbox("delivery_daytime_phone", TEXT, DELIVERY_MSG." ".DAYTIME_PHONE_FIELD);
	$r->add_textbox("delivery_evening_phone", TEXT, DELIVERY_MSG." ".EVENING_PHONE_FIELD);
	$r->add_textbox("delivery_cell_phone", TEXT, DELIVERY_MSG." ".CELL_PHONE_FIELD);
	$r->add_textbox("delivery_fax", TEXT, DELIVERY_MSG." ".FAX_FIELD);

	$r->add_textbox("registration_date", DATETIME);
	$r->change_property("registration_date", USE_IN_SELECT, false);
	$r->change_property("registration_date", USE_IN_UPDATE, false);
	$r->add_textbox("modified_date", DATETIME);
	$r->change_property("modified_date", USE_IN_SELECT, false);

	$personal_number = 0;
	$delivery_number = 0;
	for($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		$personal_param = "show_" . $parameters[$i];
		$delivery_param = "show_delivery_" . $parameters[$i];
		if(isset($user_profile[$personal_param]) && $user_profile[$personal_param] == 1) {
			$personal_number++;
			if($user_profile[$parameters[$i] . "_required"] == 1) {
				$r->parameters[$parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if(isset($user_profile[$delivery_param]) && $user_profile[$delivery_param] == 1) {
			$delivery_number++;
			if($user_profile["delivery_" . $parameters[$i] . "_required"] == 1) {
				$r->parameters["delivery_" . $parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_checkbox("same_as_personal", INTEGER);
	$r->change_property("same_as_personal", USE_IN_SELECT, false);
	$r->change_property("same_as_personal", USE_IN_INSERT, false);
	$r->change_property("same_as_personal", USE_IN_UPDATE, false);
	if($personal_number < 1 || $delivery_number < 1) {
		$r->parameters["same_as_personal"][SHOW] = false;
	}

	$r->get_form_parameters();
	$operation = get_param("operation");
	$user_id = get_param("user_id");

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $user_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql($user_id, INTEGER));		
			header("Location: " . $return_page);
			exit;
		}

		if($r->get_value("same_as_personal")) {
			for($i = 0; $i < sizeof($parameters); $i++) { 
				$personal_param = "show_" . $parameters[$i];
				$delivery_param = "show_delivery_" . $parameters[$i];
				if(isset($user_profile[$delivery_param]) && isset($user_profile[$personal_param]) &&
					$user_profile[$delivery_param] == 1 && $user_profile[$personal_param] == 1) {
					$r->set_value("delivery_" . $parameters[$i], $r->get_value($parameters[$i]));
				}
			}
		}

		$r->validate();

		if(!strlen($r->errors))
		{
			$current_date = va_time();
			if(strlen($user_id)) {
				$r->set_value("modified_date", $current_date);
				$r->update_record();
			} else {
				$password_encrypt = get_setting_value($settings, "password_encrypt", 0);
				if ($password_encrypt == 1) {
					$r->set_value("password", md5($r->get_value("password")));
				}
				$r->set_value("registration_date", $current_date);
				$r->set_value("modified_date", $current_date);
				$r->insert_record();
			}
			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($user_id))
	{
		$r->get_db_values();
	}
	else // new record (set default values)
	{
		$r->set_value("is_approved", 1);
		$r->set_value("user_type_id", $type_id);
	}

	$t->set_var("return_page", htmlspecialchars($return_page));
	$r->set_form_parameters();
	$t->set_var("type", htmlspecialchars($type));

	if($personal_number > 0)
		$t->parse("personal", false);
	else
		$t->set_var("personal", "");

	if($delivery_number > 0)
		$t->parse("delivery", false);
	else
		$t->set_var("delivery", "");

	if(strlen($user_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->parse("login_information", false);
		$t->set_var("save_button", "Add User");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>
