<?php

/*
 * ePDQ MPI handler by http://www.viart.com/
 */

	// get some variables from our payment settings
	$sslcert        = isset($payment_parameters["sslcert"]) ? $payment_parameters["sslcert"] : "";

	$pass_data = array();
	foreach ($payment_parameters as $parameter_name => $parameter_value) {
		if(isset($pass_parameters[$parameter_name]) && $pass_parameters[$parameter_name] == 1) {
			$pass_data[$parameter_name] = $parameter_value;
		}
	}

	$xml = buildXML($pass_data);

	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_URL, $advanced_url);
	curl_setopt ($ch, CURLOPT_POST, 1); 
	curl_setopt ($ch, CURLOPT_POSTFIELDS, "CLRCMRC_XML=" . $xml); 
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	if ($sslcert) {
		curl_setopt ($ch, CURLOPT_SSLCERT, $sslcert);
	}
	curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	$epdq_response = curl_exec ($ch);
	curl_close ($ch);

	if (strlen($epdq_response)) {
		$CcErrCode = ""; $CcReturnMsg = "";
		$ProcReturnCode = ""; $ProcReturnMsg = "";
		$transaction_id = "";
		if (preg_match("/<CcErrCode[^>]*>(.*)<\/CcErrCode>/i", $epdq_response, $match)) {
			$CcErrCode = $match[1];
		}
		if (preg_match("/<CcReturnMsg[^>]*>(.*)<\/CcReturnMsg>/i", $epdq_response, $match)) {
			$CcReturnMsg = $match[1];
		}
		if (preg_match("/<ProcReturnCode[^>]*>(.*)<\/ProcReturnCode>/i", $epdq_response, $match)) {
			$ProcReturnCode = $match[1];
		}
		if (preg_match("/<ProcReturnMsg[^>]*>(.*)<\/ProcReturnMsg>/i", $epdq_response, $match)) {
			$ProcReturnMsg = $match[1];
		}
		if (preg_match("/<Transaction[^>]*>.*<Id[^>]*>(.*)<\/Id>.*<\/Transaction>/is", $epdq_response, $match)) {
			$transaction_id = $match[1];
		}

		if (!strlen($ProcReturnCode) && !strlen($CcErrCode)) {
			if (preg_match("/<MessageList>(.*)<\/MessageList>/is", $epdq_response, $match)) {
				$messages = trim($match[1]);
				if (preg_match_all("/<Message>.*<Text[^>]*>(.*)<\/Text>.*<\/Message>/isU", $messages, $matches)) {
					for($p = 0; $p < sizeof($matches[1]); $p++) {
						$message = trim($matches[1][$p]);
						if ($message) {
							$error_message .= $message . "<br>";
						}
					}
				} 
			}
			if (!$error_message) {
				$error_message = "Can't obtain transaction status.";
			}
		} else if (!strlen($ProcReturnCode)) {
			$error_message = "Can't obtain transaction status.";
		} else if ($ProcReturnCode != "00") {
			$error_message  = "Some errors occurred during handling your transaction:<br>";
			$error_message .= $ProcReturnCode . ": " . $ProcReturnMsg;
		} else if (!strlen($CcErrCode)) {
			$error_message = "Can't obtain engine status.";
		} else if ($CcErrCode != 1) {
			$error_message  = "Some engine errors occurred during handling your transaction:<br>";
			$error_message .= $CcErrCode . ": " . $CcReturnMsg;
		} else if (!$transaction_id) {
			$error_message  = "Can't obtain transaction parameter.";
		} else {
			// transaction was approved
			$avs_response = ""; $cvv2_response = ""; $proc_avs_response = "";
			if (preg_match("/<AvsRespCode [^>]*>(.*)<\/AvsRespCode >/i", $epdq_response, $match)) {
				$avs_response = $match[1];
			}
			if (preg_match("/<Cvv2Resp[^>]*>(.*)<\/Cvv2Resp>/i", $epdq_response, $match)) {
				$cvv2_response = $match[1];
			}
			if (preg_match("/<ProcAvsRespCode[^>]*>(.*)<\/ProcAvsRespCode>/i", $epdq_response, $match)) {
				$proc_avs_response = $match[1];
			}
		}
	} else {
		$error_message  = "Empty response from engine, please check your payment settings.";
	}

	if ($error_message) {
		$error_message = str_replace("&apos;", "'", $error_message);
	}

	function buildXML($params) 
	{
		global $token;

		$xml = '
<?xml version="1.0" encoding="UTF-8"?>
<EngineDocList>
	<DocVersion>1.0</DocVersion>
	<EngineDoc>
		<ContentType>OrderFormDoc</ContentType>
		<User>';

		$username = (isset($params["username"])) ? $params["username"] : "";
		$password = (isset($params["password"])) ? $params["password"] : "";
		$clientid = (isset($params["clientid"])) ? $params["clientid"] : "";
		$xml .= "<Name>" . $username . "</Name>\r\n";
		$xml .= "<Password>" . $password . "</Password>\r\n";
		$xml .= "<ClientId DataType=\"S32\">" . $clientid . "</ClientId>";
		$xml .= '
		</User>
		<Instructions>
			<Pipeline>PaymentNoFraud</Pipeline>
		</Instructions>';

		$xml .= "<OrderFormDoc>";
		$mode = (isset($params["mode"])) ? $params["mode"] : "";
		$xml .= "<Mode>" . $mode . "</Mode>\r\n";
		$xml .= "
			<Comments/>
			<Consumer>\r\n";
				if(isset($params["email"]) && strlen($params["email"])) {
					$xml .= "<Email>" . $params["email"] . "</Email>\r\n";
				} else {
					$xml .= "<Email/>\r\n";
				}
		$xml .= "
				<PaymentMech>
					<CreditCard>";
		$ccnumber = (isset($params["ccnumber"])) ? $params["ccnumber"] : "";
		$ccexpires = (isset($params["ccexpires"])) ? $params["ccexpires"] : "";
		$cvv2val = (isset($params["cvv2val"])) ? $params["cvv2val"] : "";
		$xml .= "<Number>" . $ccnumber . "</Number>\r\n";
		$xml .= "<Expires DataType=\"ExpirationDate\" Locale=\"840\">" . $ccexpires . "</Expires>\r\n";
		if(isset($params["cvv2val"]) && strlen($params["cvv2val"])) {
			$xml .= "<Cvv2Val>" . $params["cvv2val"] . "</Cvv2Val>\r\n";
			$xml .= "<Cvv2Indicator>1</Cvv2Indicator>\r\n";
		} 
		if(isset($params["ccissuenum"]) && strlen($params["ccissuenum"])) {
			$xml .= "<IssueNum>" . $params["ccissuenum"] . "</IssueNum>\r\n";
		}
		if(isset($params["ccstartdate"]) && preg_match("/^\d{2}\/\d{2}$/", $params["ccstartdate"])) {
			$xml .= "<StartDate>" . $params["ccstartdate"] . "</StartDate>\r\n";
		}
		if(isset($params["cctype"]) && strlen($params["cctype"])) {
			$cc_type = $params["cctype"];
			$cc_types = array ("visa" => "1", "mc" => "2", "mastercard" => "2", "discover" => "3", 
				"diners" => "4", "dinersclub" => "4", "carteblanche" => "5", "jcb" => "6", "enroute" => "7", 
				"amex" => "8", "american express" => "8", "americanexpress" => "8",
				"solo" => "9", "switch" => "10", "electron" => "11"
			);
			if (isset($cc_types[strtolower($cc_type)])) {
				$cc_type = $cc_types[strtolower($cc_type)];
			}
			$xml .= "<Type>" . $cc_type . "</Type>\r\n";
		} 

		$xml .= '
					</CreditCard>
				</PaymentMech>';

		$xml .= '
				<BillTo>
					<Location>';
		if(isset($params["billemail"]) && strlen($params["billemail"])) {
			$xml .= "<Email>" . $params["billemail"] . "</Email>\r\n";
		}
		if(isset($params["billtelfax"]) && strlen($params["billtelfax"])) {
			$billtelfax = preg_replace("/[^\d]/", "", $params["billtelfax"]);
			$xml .= "<TelFax>" . $billtelfax . "</TelFax>\r\n";
		}
		if(isset($params["billtelvoice"]) && strlen($params["billtelvoice"])) {
			$billtelvoice = preg_replace("/[^\d]/", "", $params["billtelvoice"]);
			$xml .= "<TelVoice>" . $billtelvoice . "</TelVoice>\r\n";
		}
		$xml .= '<Address>';
		if(isset($params["billname"]) && strlen($params["billname"])) {
			$xml .= "<Name>" . $params["billname"] . "</Name>\r\n";
		}
		if(isset($params["billfirstname"]) && strlen($params["billfirstname"])) {
			$xml .= "<FirstName>" . $params["billfirstname"] . "</FirstName>\r\n";
		}
		if(isset($params["billlastname"]) && strlen($params["billlastname"])) {
			$xml .= "<LastName>" . $params["billlastname"] . "</LastName>\r\n";
		}
		if(isset($params["billstreet1"]) && strlen($params["billstreet1"])) {
			$xml .= "<Street1>" . $params["billstreet1"] . "</Street1>\r\n";
		}
		if(isset($params["billstreet2"]) && strlen($params["billstreet2"])) {
			$xml .= "<Street2>" . $params["billstreet2"] . "</Street2>\r\n";
		}
		if(isset($params["billcity"]) && strlen($params["billcity"])) {
			$xml .= "<City>" . $params["billcity"] . "</City>\r\n";
		}
		if(isset($params["billstateprov"]) && strlen($params["billstateprov"])) {
			$xml .= "<StateProv>" . $params["billstateprov"] . "</StateProv>\r\n";
		}
		if(isset($params["billpostalcode"]) && strlen($params["billpostalcode"])) {
			$xml .= "<PostalCode>" . $params["billpostalcode"] . "</PostalCode>\r\n";
		}
		if(isset($params["billcountry"]) && strlen($params["billcountry"])) {
			$xml .= "<Country>" . $params["billcountry"] . "</Country>\r\n";
		}
		if(isset($params["billcompany"]) && strlen($params["billcompany"])) {
			$xml .= "<Company>" . $params["billcompany"] . "</Company>\r\n";
		}
		$xml .= '
						</Address>
					</Location>
				</BillTo>';

		$shipname = (isset($params["shipname"])) ? $params["shipname"] : "";
		$shipfirstname = (isset($params["shipfirstname"])) ? $params["shipfirstname"] : "";
		$shiplastname = (isset($params["shiplastname"])) ? $params["shiplastname"] : "";
		$shipstreet1 = (isset($params["shipstreet1"])) ? $params["shipstreet1"] : "";
		$shipstreet2 = (isset($params["shipstreet2"])) ? $params["shipstreet2"] : "";
		$shipcity = (isset($params["shipcity"])) ? $params["shipcity"] : "";
		$shipstateprov = (isset($params["shipstateprov"])) ? $params["shipstateprov"] : "";
		$shippostalcode = (isset($params["shippostalcode"])) ? $params["shippostalcode"] : "";
		$shipcountry = (isset($params["shipcountry"])) ? $params["shipcountry"] : "";
		$shipcompany = (isset($params["shipcompany"])) ? $params["shipcompany"] : "";
		if (strlen($shipname) || strlen($shipfirstname) || strlen($shiplastname) || strlen($shipstreet1) || strlen($shipstreet2) || strlen($shipcity) || strlen($shipstateprov) || strlen($shipcountry) || strlen($shippostalcode) || strlen($shipcompany)) {
			$xml .= '
				<ShipTo>
					<Location>';
			if(isset($params["shipemail"]) && strlen($params["shipemail"])) {
				$xml .= "<Email>" . $params["shipemail"] . "</Email>\r\n";
			}
			if(isset($params["shiptelfax"]) && strlen($params["shiptelfax"])) {
				$shiptelfax = preg_replace("/[^\d]/", "", $params["shiptelfax"]);
				$xml .= "<TelFax>" . $shiptelfax . "</TelFax>\r\n";
			}
			if(isset($params["shiptelvoice"]) && strlen($params["shiptelvoice"])) {
				$shiptelvoice = preg_replace("/[^\d]/", "", $params["shiptelvoice"]);
				$xml .= "<TelVoice>" . $shiptelvoice . "</TelVoice>\r\n";
			}
			$xml .= '<Address>';
			if(strlen($shipname)) {
				$xml .= "<Name>" . $shipname . "</Name>\r\n";
			}
			if(strlen($shipfirstname)) {
				$xml .= "<FirstName>" . $shipfirstname . "</FirstName>\r\n";
			}
			if(strlen($shiplastname)) {
				$xml .= "<LastName>" . $shiplasttname . "</LastName>\r\n";
			}
			if(strlen($shipstreet1)) {
				$xml .= "<Street1>" . $shipstreet1 . "</Street1>\r\n";
			}
			if(strlen($shipstreet2)) {
				$xml .= "<Street2>" . $shipstreet2 . "</Street2>\r\n";
			}
			if(strlen($shipcity)) {
				$xml .= "<City>" . $shipcity . "</City>\r\n";
			}
			if(strlen($shipstateprov)) {
				$xml .= "<StateProv>" . $shipstateprov . "</StateProv>\r\n";
			}
			if(strlen($shippostalcode)) {
				$xml .= "<PostalCode>" . $shippostalcode . "</PostalCode>\r\n";
			}
			if(strlen($shipcountry)) {
				$xml .= "<Country>" . $shipcountry . "</Country>\r\n";
			}
			if(strlen($shipcompany)) {
				$xml .= "<Company>" . $shipcompany . "</Company>\r\n";
			}
			$xml .= '
						</Address>
					</Location>
				</ShipTo>';
		}
		$xml .= '
			</Consumer>
			<Transaction>';

		$type = (isset($params["type"])) ? $params["type"] : "";
		$xml .= "<Type>" . $type . "</Type>\r\n";
		if(isset($params["ponumber"]) && strlen($params["ponumber"])) {
			$xml .= "<PoNumber>" . $params["ponumber"] . "</PoNumber>\r\n";
		} 
		$xml .= '
				<CurrentTotals>
					<Totals>';
		$currency = (isset($params["currency"])) ? $params["currency"] : "";
		$ordertotal = (isset($params["ordertotal"])) ? $params["ordertotal"] : "";
		$xml .= "<Total DataType=\"Money\" Currency=\"" . $currency . "\">" . $ordertotal . "</Total>";
		$xml .= '
					</Totals>
				</CurrentTotals>
			</Transaction>
		</OrderFormDoc>
	</EngineDoc>
</EngineDocList>';

		return $xml;
	}

?>